export declare type AutomataSpec<X extends string, S = any, P = any, A = StandardAction<P>> = {
    [state in X]: ReducerSpec<X, S, P, A>;
};
export interface ReducerSpec<X extends string, S = any, P = any, A = StandardAction<P>> {
    [type: string]: (Reducer<S, P, A> | X)[] | Reducer<S, P, A> | X;
}
export declare type Reducer<S, P = any, A = StandardAction<P>> = (state: S, action: A) => S;
export interface StandardAction<P = any> {
    type: string;
    payload?: P;
}
export interface AutomataReducerOptions<X extends string = string, K extends string = 'state', I extends {
    [key in K]: X;
} = {
    [key in K]: X;
}, O = I, P = any> {
    key: K;
    toStandardAction: ActionStandardizer<P>;
    operator: Operator<I, O>;
}
export declare type ActionStandardizer<P = any> = <A>(action: A) => StandardAction<P>;
export declare type Operator<I = {}, O = I> = (fn: (i: I, ...args: any[]) => I) => (o: O, ...args: any[]) => O;
export default function createAutomataReducer<X extends string, K extends string = 'state', I extends {
    [key in K]: X;
} = {
    [key in K]: X;
}, O = I, P = any, A = StandardAction<P>>(automata: AutomataSpec<X, I, P, A>, init: X, opts?: Partial<AutomataReducerOptions<X, K, I, O, P>> | string): Reducer<O, P, A>;
